import logging
from enum import Enum

class VariableType(Enum):
    PRESSURE = 1
    VOLTAGE = 2
    CURRENT = 3
    PACK_TEMPERATURE = 4
    AMBIENT_TEMPERATURE = 5

class CodesysMachineState():
    OPERATIONAL = int()
    OPERATIONAL_WITH_LOW_SOC = int()
    OPERATIONAL_DISCHARGE_NOT_ALLOWED = int()
    OPERATIONAL_WITH_HIGH_SOC = int()
    OPERATIONAL_CHARGE_NOT_ALLOWED = int()
    OPERATIONAL_RANGE = range(0)
    ALARM_RANGE = range(0)

class OpcTag():
    MACHINE_STATE = None

class ScriptFunctions(object):
    def __init__(self) -> None:
        self.result = (False, "Script is not initialized")

    def log_info(self, msg: str) -> None:
        logging.info("### executor script: {}".format(msg))

    def script_pass(self) -> None:
        self.log_info("script_pass")

    def script_fail(self) -> None:
        self.log_info("script_fail")
        raise Exception("Failure!")

    def initialize_imu_sim(self) -> None:
        self.log_info("initialize_imu_sim")

    def get_imu_value(self, var_type: VariableType, node_id: int) -> float:
        self.log_info("get_imu_value: {}".format(locals()))

    def change_var(self, var_type: VariableType, target: float, delta_minute: float, reference_node: int, valid_machine_states: range) -> None:
        self.log_info("change_var: {}".format(locals()))

    def wait_for_machine_state_in_range(self, valid_machine_states: range, timeout_secs=60) -> None:
        self.log_info("wait_for_machine_state_in_range: {}".format(locals()))

    def emulator_send(self, command_string: str):
        self.log_info("emulator_send: {}".format(locals()))